import { Component, OnInit,AfterViewInit,Output,Input,EventEmitter,ViewChild,ElementRef } from '@angular/core';
import { Subject,Unsubscribable } from 'rxjs';
import { ActivatedRoute } from '@angular/router';
import { NavController,ModalController } from '@ionic/angular';
import { AppNotification } from '@global/service/Notification';
import { App } from '@global/service/App';
import { Http } from '@global/service/Http';
import { ComUtil } from '@global/util/ComUtil';
import { AppEnvironment } from 'src/environments/AppEnvironment';

import { QJQJSP_D_MobWFEditViewPage } from '@pages/demo/qjqjsp-d-mob-wfedit-view/qjqjsp-d-mob-wfedit-view.page';

import MobWFMDViewEngine from 'src/engine/view/mob-wfmdview-engine';
import { Mdctrl } from '@widget/qj/mob-mobmdctrl/mob-mobmdctrl';
import { Righttoolbar } from '@widget/qj/qjsp-d-mob-wfmdviewrighttoolbar-toolbar/qjsp-d-mob-wfmdviewrighttoolbar-toolbar';

@Component({
  selector: 'view-qjqjsp-d-mob-wfmdview',
  templateUrl: './qjqjsp-d-mob-wfmdview.page.html',
  styleUrls: ['./qjqjsp-d-mob-wfmdview.page.scss']
})
export class QJQJSP_D_MobWFMDViewPage implements OnInit,AfterViewInit {

    /**
     * 子组件Mdctrl
     *
     * @public
     * @type {Subject}
     * @memberof QJQJSP_D_MobWFMDView
     */
    @ViewChild(Mdctrl)
    private mdctrl: Mdctrl;

    /**
     * 子组件Righttoolbar
     *
     * @public
     * @type {Subject}
     * @memberof QJQJSP_D_MobWFMDView
     */
    @ViewChild(Righttoolbar)
    private righttoolbar: Righttoolbar;

    /**
     * 视图订阅对象
     *
     * @public
     * @type {Subject}
     * @memberof QJQJSP_D_MobWFMDView
     */
    public viewState: Subject<ViewState> = new Subject();

    /**
     * 路由传递参数
     *
     * @public
     * @type {void}
     * @memberof QJQJSP_D_MobWFMDView
     */
    public $route ={};

    /**
     * 当前视图激活数据
     *
     * @public
     * @type {void}
     * @memberof QJQJSP_D_MobWFMDView
     */
    public $activeData:Array<any> =[];

    /**
     * 是否为模态框弹出
     *
     * @memberof QJQJSP_D_MobWFMDView
     */
    @Input() isModalMode:boolean =false;

    /**
     * 是否嵌入分页导航视图
     *
     * @memberof TestEntity2MobPickupView
     */
    @Input() isTabexp:boolean =false;

    /**
     * 视图值变化事件
     *
     * @public
     * @type {EventEmitter}
     * @memberof QJQJSP_D_MobWFMDView
     */    
    @Output() public viewdataschange =new EventEmitter();

    /**
     * 视图参数
     *
     * @public
     * @type {Subject}
     * @memberof QJQJSP_D_MobWFMDView
     */
    @Input() public viewdata:any;

    /**
     * 父数据对象
     *
     * @protected
     * @type {*}
     * @memberof QJQJSP_D_MobWFMDView
     */
    protected srfparentdata: any = {};

    /**
     * 是否为内敛视图
     *
     * @public
     * @type {EventEmitter}
     * @memberof QJQJSP_D_MobWFMDView
     */ 
    @Input() public isembeddedView:boolean =false;

    /**
     * 视图值加载完成事件
     *
     * @public
     * @type {EventEmitter}
     * @memberof QJQJSP_D_MobWFMDView
     */ 
    @Output() public viewload =new EventEmitter();

    /**
     * 视图的关联试图Map
     *
     * @public
     * @type {Map}
     * @memberof QJQJSP_D_MobWFMDView
     */
    public RefViewMap =new Map();

    /**
     * 视图引擎
     *
     * @private
     * @type {Engine}
     * @memberof QJQJSP_D_MobWFMDView
     */
    private engine: MobWFMDViewEngine = new MobWFMDViewEngine();

    /**
     * 引擎初始化
     *
     * @private
     * @memberof QJQJSP_D_MobWFMDView
     */
    private engineInit(): void {
        this.engine.init({
            view: this,
            opendata: (params: any) => {
                this.opendata(params);
            },
            mdctrl: this.mdctrl,
            newdata: (params: any) => {
                this.newdata(params);
            },
        });
    }


     /**
     * angular生命周期(在ngOnInit之后)
     *
     * @memberof QJQJSP_D_MobWFMDView
     */
    public ngAfterViewInit(){
        this.engineInit();
        this.viewState.next({ tag:'mdctrl', action: 'load', data: this.viewdata?this.viewdata:{} });

        this.registerRefView();
    }

        /**
    * 新建
    *
    * @param {*} [arg={}]
    * @param {*} [params]
    * @memberof QJQJSP_D_MobWFMDView
    */
    public New(args: any[], params?: any, $event?: any, xData?: any) {
         const _this: any = this;
        if (_this.newdata && _this.newdata instanceof Function) {
            const data: any = {};
            if (_this.srfparentdata) {
                Object.assign(data, _this.srfparentdata);
            }
            _this.newdata([{ ...data }], params, $event, xData);
        } else {
            this.$notification.error('错误,视图处理逻辑不存在，请添加!');
        }
    }
        /**
    * 帮助
    *
    * @param {*} [arg={}]
    * @param {*} [params]
    * @memberof QJQJSP_D_MobWFMDView
    */
    public Help(args: any[], params?: any, $event?: any, xData?: any) {
       this.$notification.info('帮助界面行为');
    }

    /**
     * mdctrl 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof TestEntityEditView
     */
    public mdctrl_load($event: any, $event2?: any) {
        this.engine.onCtrlEvent('mdctrl', 'load', $event);
    }

    /**
     * mdctrl 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof TestEntityEditView
     */
    public mdctrl_click($event: any, $event2?: any) {
        this.engine.onCtrlEvent('mdctrl', 'click', $event);
    }

    /**
     * righttoolbar 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof TestEntityEditView
     */
    public righttoolbar_click($event: any, $event2?: any) {
        if (Object.is($event.tag, 'tbitem3')) {
            this.righttoolbar_tbitem3_click($event, '', $event2);
        }
        if (Object.is($event.tag, 'tbitem5')) {
            this.righttoolbar_tbitem5_click($event, '', $event2);
        }
    }


    /**
     * 部件逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @memberof QJQJSP_D_MobWFMDView
     */
    public righttoolbar_tbitem3_click(params: any = {}, tag?: any, $event?: any) {
        // 参数

        // 取数
        let datas: any[] = [];
        let xData: any = null;
        const paramJO = {};
        xData = this.mdctrl;
        datas = [...xData.getDatas()];
        // 界面行为
        this.New(datas, paramJO,  $event, xData);
    }
    /**
     * 部件逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @memberof QJQJSP_D_MobWFMDView
     */
    public righttoolbar_tbitem5_click(params: any = {}, tag?: any, $event?: any) {
        // 参数

        // 取数
        let datas: any[] = [];
        let xData: any = null;
        const paramJO = {};
        xData = this.mdctrl;
        datas = [...xData.getDatas()];
        // 界面行为
        this.Help(datas, paramJO,  $event, xData);
    }
    
    /**
     * 打开新建数据视图
     *
     * @param {*} [params={}]
     * @memberof QJQJSP_D_MobWFMDView
     */
    public async newdata(params: any = {}) {
        if(this.isembeddedView){
                const modal = await this.$modalCtrl.create({
                component:QJQJSP_D_MobWFEditViewPage,
                componentProps: { viewdata: {'srfkey':params.srfkey,'parentdata':this.viewdata},isModalMode:true }
            });
            await modal.present();
            const result = await modal.onWillDismiss();
            if(Object.is(result.data.ret,'OK')){
                this.viewState.next({tag:'mdctrl', action:'load', data:this.viewdata?JSON.parse(this.viewdata):{}});
            }
        }else{
            this.$navCtrl.navigateForward(['demo_qjqjsp_d_mobwfeditview'],{queryParams:{'srfkey':params.srfkey,'parentdata':this.viewdata}});
            this.$app.nextViewCloseCallback((data:any) =>{
                if(Object.is(data.ret,'OK')){
                    this.viewState.next({tag:'mdctrl', action:'load', data:this.viewdata?JSON.parse(this.viewdata):{}});
                }
            });
        }
    }

    
    /**
     * 打开编辑数据视图
     *
     * @param {*} [params={}]
     * @memberof QJQJSP_D_MobWFMDView
     */
    public async opendata(params: any = {}) {
         const data: any = { srfkey: params.srfkey, srfsourcekey: params.srfsourcekey };
        if(this.isembeddedView){
                const modal = await this.$modalCtrl.create({
                component:QJQJSP_D_MobWFEditViewPage,
                componentProps: { viewdata: {'srfkey':params.srfkey,'parentdata':this.viewdata},isModalMode:true }
            });
            await modal.present();
            const result1 = await modal.onWillDismiss();
            if(Object.is(result1.data.ret,'OK')){
                this.viewState.next({tag:'mdctrl', action:'load', data:this.viewdata?JSON.parse(this.viewdata):{}});
            }
        }else{
            this.$navCtrl.navigateForward(['demo_qjqjsp_d_mobwfeditview'],{queryParams:{'srfkey':params.srfkey,'parentdata':this.viewdata}});
            this.$app.nextViewCloseCallback((data:any) =>{
                if(Object.is(data.ret,'OK')){
                    this.viewState.next({tag:'mdctrl', action:'load', data:this.viewdata?JSON.parse(this.viewdata):{}});
                }
            });
        }
    }


    /**
     * 返回
     *
     * @memberof QJQJSP_D_MobWFMDView
     */
    public backView() {
        let res:any;
        if(this.isModalMode){
            if(this.$activeData && this.$activeData.length >0){
                res = { ret: 'OK', result:this.$activeData };
            }else{
                res = { ret: 'NO', result:[] };
            }
            this.$modalCtrl.dismiss(res, 'close');
        }else{
            this.$navCtrl.back();
            if(this.$activeData && this.$activeData.length >0){
                res = { ret: 'OK', result:this.$activeData };
            }else{
                res = { ret: 'NO', result:[] };
            }
            this.$app.closeCallback(res);
        }
    }

    /**
     * 嵌入视图点击更多
     *
     * @public
     * @memberof QJQJSP_D_MobWFMDView
     */
    public async click_more(){
        let leftopts:Array<any> =[
    ];
        let rightopts:Array<any> =[
        {text:'新建',id:'righttoolbar_tbitem3'},
        {text:'帮助',id:'righttoolbar_tbitem5'},
    ];
        let opts:Array<any>=leftopts.concat(rightopts);
        const result: string = await this.$app.openActionSheet({items:opts});
        let _this =this;
        if(result.startsWith('righttoolbar')){
            if(_this && _this.righttoolbar_click && _this.righttoolbar_click instanceof Function){
                let firstIndex = result.indexOf('_');
                _this.righttoolbar_click({tag:result.substring(firstIndex + 1)});
            }
        }
    }

    /**
     * 点击toolbar的操作组事件
     *
     * @public
     * @memberof QJQJSP_D_MobWFMDView
     */
    public  async openActionSheet(data:any){

        if(Object.is(data,'tbitem1')){
            let opts={items:[
                            {id:'tbitem5',text:'帮助'}
            ]};
            if(opts.items.length === 0){
                return;
            }
            const tag: string = await this.$app.openActionSheet(opts);
            this.righttoolbar_click({tag:tag});
        }
        
    }

    /**
     * 注册关联视图
     *
     * @public
     * @memberof QJQJSP_D_MobWFMDView
     */    
    public registerRefView(){
        this.RefViewMap.set('QJQJSP_D_MobWFEditView',QJQJSP_D_MobWFEditViewPage);
    }   

    

    /**
     * 实例化对象
     *
     * @memberof QJQJSP_D_MobWFMDView
     */
    constructor(public $http:Http,public $navCtrl: NavController, public $notification: AppNotification, public $activatedRoute: ActivatedRoute,public $modalCtrl:ModalController,public $app:App) {
        this.$activatedRoute.queryParams.subscribe(params => {
        this.$route ="";
        if(params){
            this.$route =JSON.stringify(params);
        }
        })
    }

    /**
     * angular生命周期(组件初始化)
     *
     * @memberof QJQJSP_D_MobWFMDView
     */
    public ngOnInit() {
       
    }

    /**
     * 视图抛出值变化事件
     *
     * @public
     * @memberof QJQJSP_D_MobWFMDView
     */
    public viewDataChanges($event:any){
        this.viewdataschange.emit($event);
    }
}


